# Learnable Model Verification Through Reinforcement Learning (LFCPS Project)

Contributed by:
Yao Feng & Anita Li

This repo contains a series of examples and environment to test and challenge reinforcement learning algorithms
in safe environments. We modifed code based on **Verifiably Safe Reinforcement Learning framework** (https://github.com/IBM/vsrl-framework).

## Model Proofs:
The KeYmaera X verifications are stored in [`verification`](./verification)
- CACC.kyx (Model to prove safety of environment CACC)
- GoalFinding.kyx (Model to prove safety of envrionment GoalFinding and Pointmess)

## Requirements
- [>= Python 3.6](https://www.python.org/downloads/)

### Setup
Clone the repository and open the project folder.
```
pip install -r requirements.txt
```

## Getting started
Environment code are defined in  [`envs`](./env) using OpenAI Gym implementations.
RL code are defined in  [`rl`](./rl).
We run the training process for
- CACC: 
```
python main_cacc.py
```
- Goal Finding:
```
python main_pmgoalfinding.py --env=GoalFinding
```
- Pointmess:
```
python main_pmgoalfinding.py --env=Pointmess
```
