from verifier.keymaerax import KeYmaeraXTool
import verifier.expr as expr
import verifier.expr_helper as expr_helpers
from verifier.keymaerax_pretty_printer import keymaerax_pp

proof_checker = KeYmaeraXTool()
def create_model(x,v,a):
    T = 0.1
    s = keymaerax_pp(
            expr.Imply(
                expr.And(
                    expr.Eq(expr.Variable("x"), expr.Number(x)),
                    expr.Eq(expr.Variable("v"), expr.Number(v))
                ),
            expr.Box(
                expr.SequentialCompose(
                    expr.Assign(expr.Variable("t"), expr.Number(0)),
                    expr.ODESystem(
                        dp=expr.DiffPair(
                            expr.AtomicODE(expr.Variable("x"), expr.Variable("v")),
                            expr.DiffPair(
                                expr.AtomicODE(expr.Variable("v"), expr.Variable("a")),
                                expr.DiffPair(
                                    expr.AtomicODE(expr.Variable("a"), expr.Number(a)),
                                    expr.AtomicODE(expr.Variable("t"), expr.Number(1)),
                                )
                            )
                        ),
                        constraint=expr.LessEq(expr.Variable("t"), expr.Number(T))
                    )
                    ), expr.GreaterEq(expr.Variable("x"), expr.Number(0))
                )
            ))
    print(s)

def main():
    x,v,a = 100,-30,-1
    create_model(x,v,a)
    

main()